import java.sql.*;
import java.util.ArrayList;
import java.util.List;

public class UsuarioBeanImpl implements UsuarioBean {

    //Sobreescribimos los métodos de la Interfaz

    //Definimos el método para conectarnos a la BD
    public static Connection getConnection() throws SQLException {
        String BBDD = "jdbc:mysql://localhost:3306/m06Bean";
        String USER = "root"; //Aquí van mis datos de conexión en XAMPP
        String PASSWORD = "";
        return DriverManager.getConnection(BBDD, USER, PASSWORD);
    }

    @Override
    public List<Usuario> getUsuarios() throws SQLException {
        //Vamos a consultar todos los usuarios que existen en la BD
        List<Usuario> usuarios = new ArrayList<>();
        Statement sentencia = getConnection().createStatement();
        //Creamos un statement para lanzar la consulta y recogemos el resultado en ResultSet
        ResultSet resultSet = sentencia.executeQuery("SELECT * FROM Usuarios");
        while (resultSet.next()) {
            //Debemos tener un constructor de Usuario que reciba un ResultSet
            usuarios.add(new Usuario(resultSet));
        }
        sentencia.close();
        return usuarios;
    }

    public void insertUsuario(Usuario usuario) throws SQLException {
        Statement sentencia = getConnection().createStatement();
        String insert = String.format("INSERT INTO Usuarios(nombre, apellido, mail, telf) VALUES(\"%s\",\"%s\", \"%s\", \"%s\" );",
                usuario.getNombre(), usuario.getApellido(), usuario.getMail(), usuario.getTelf());
        System.out.println(insert);
        sentencia.executeUpdate(insert);
    }
}
